//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DEncrypt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "aTzGrids"
#pragma link "TzPrimDS"
#pragma link "UCommon"
#pragma link "UTzCDS"
#pragma link "UTzFDS"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  UpdateCaption();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  // decrypt the file for the next demo
  if (FEncrypted) DecryptButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TopazButtonClick(TObject *Sender)
{
  // file is gobbly-gook on disk, but perfectly readable here
  if (FEncrypted)
    SpecialSetEncrypt(doBoth); // or TzDbf1->SetEncrypt(ScrambleX, UnScrambleX);
  else
    SpecialSetEncrypt(doNone); // or TzDbf1->SetEncrypt(NULL, NULL);
  TzDbf1->GoTop();
  TzDbf1->ReadOnly = FALSE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OthersButtonClick(TObject *Sender)
{
 // file is gobbly-gook for other people
  SpecialSetEncrypt(doNone); // or TzDbf1.SetEncrypt(NULL, NULL);
  TzDbf1->GoTop();
  TzDbf1->ReadOnly = TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EncryptButtonClick(TObject *Sender)
{
  // encrypt a normal file
  if (FEncrypted)
    ShowMessage("File is already encrypted");
  else {
    SpecialSetEncrypt(doEncrypt); // or you may simply use the following:
                                  // TzDbf1->SetEncrypt(ScrambleA, NULL);
    TzDbf1->ReplaceAllRecords();
    ShowMessage("File is encrypted, but TOPAZ can see it");
  }
  FEncrypted = TRUE;
  TopazButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DecryptButtonClick(TObject *Sender)
{
  // decrypt the file
  if (FEncrypted == FALSE)
    ShowMessage("File is not encrypted");
  else {
    SpecialSetEncrypt(doDecrypt); // or TzDbf1.SetEncrypt(NULL, UnScramble);
    TzDbf1->ReplaceAllRecords();
    FEncrypted = FALSE;
    TopazButtonClick(Sender);
    ShowMessage("File is decrypted now");
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ChangeEncryptionButtonClick(TObject *Sender)
{
  // we are about to change the encoding method.
  // if the file is not encrypted we simply flip the flag:

  if (FEncrypted == FALSE)
    FUseMethodA = ! FUseMethodA;
  else {
    /* if the file is already encrypted then we need to decrypt
       the whole file, flip the flag and then encrypt the file
       using the new method. NEVER change encryption/decryption
       routines while the file is encrypted. You'll end up losing
       your data. */
    DecryptButtonClick(Sender);
    FUseMethodA = ! FUseMethodA;
    EncryptButtonClick(Sender);
  }
  UpdateCaption();
}
//---------------------------------------------------------------------------

/*
  Scramble and UnScramble methods are provided by the programmer.
  You may use encoding/decoding algorithms of any complexity.
  In this sample we'll use two different types of encoding/decoding.

  -- Method_A --------
  ScrambleA uses a simple encoding routine that simply increments the
  ASCII value of each byte by one. The corresponding decoding routine
  UnScrambleA decrements the ASCII value of each byte by one.

  -- Method_B --------
  The second encoding method shown in SymmetricalRoutine() uses a more
  complex way of encoding the bytes. It XORs each byte with a constant
  (in this case it is ASCII 197) and reverses the order of the bytes.
  (The routine flips the buffer so that the very first byte ends up as
  the last and vice versa, etc.). This algorithm is symmetrical: if you run
  it twice on the same buffer you get the original buffer back. Therefore
  the same routine can be used as scrambler and de-scrambler.

  Encoding/Decoding in TOPAZ is done on a record-by-record basis. */

/*---------------------------------------------------------------------------*/

static void __fastcall ScrambleA(char *p, Word Size)
{
  for (Word i = 0; i < Size; i++, p++) ++(*p); // add 1 to the char
}

static void __fastcall UnScrambleA(char *p, Word Size)
{
  for (Word i = 0; i < Size; i++, p++) --(*p); // subtract 1 from the char
}

/*---------------------------------------------------------------------------*/
static void __fastcall SymmetricalRoutine(char *p, Word Size)
{
  #define XOR_MASK 197
  Word i;
  char temp;
  Byte *q = (Byte *)p;

  for (i = 0; i < Size; i++, q++)
    *q = (*q) ^ (Byte)XOR_MASK;

  q--; // now q is positioned at the end of our buffer
  for (i = 0; i < (Size / 2); i++, p++, q--)
  {
    temp = *p;
    *p   = *q;
    *q   = temp;
  }
}
/*---------------------------------------------------------------------------*/

/*
  This function will select one way of encryptin or the other depending
  on a flag. This flag called FUseMethodA is flipped on a button
  click. In a common case your application will use only a single
  pair of encryption/decryption. We need our own SpecialSetEncrypt
  only in this sample application.
*/

void __fastcall TForm1::SpecialSetEncrypt(MyEncryptionType eType)
{
  if (FUseMethodA) { // use ScranmbleA and UnScrambleA
    switch (eType) {
      case doEncrypt: TzDbf1->SetEncrypt(ScrambleA, NULL);        break;
      case doDecrypt: TzDbf1->SetEncrypt(NULL, UnScrambleA);      break;
      case doBoth:    TzDbf1->SetEncrypt(ScrambleA, UnScrambleA); break;
      default:        TzDbf1->SetEncrypt(NULL, NULL);             break;
    }
  }
  else {             // use SymmetricalRoutine
    switch (eType) {
      case doEncrypt: TzDbf1->SetEncrypt(SymmetricalRoutine, NULL); break;
      case doDecrypt: TzDbf1->SetEncrypt(NULL, SymmetricalRoutine); break;
      case doBoth:    TzDbf1->SetEncrypt(SymmetricalRoutine, SymmetricalRoutine); break;
      default:        TzDbf1->SetEncrypt(NULL, NULL);               break;
    }
  }
}

void __fastcall TForm1::UpdateCaption(void)
{
  if (FUseMethodA)
    ChangeEncryptionButton->Caption = "&Use encryption method B";
  else
    ChangeEncryptionButton->Caption = "&Use encryption method A";
}




