unit Dencrypt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, aTzGrids, UCommon, UTzODbf, UTzDbf, ExtCtrls,
  aTzNav, StdCtrls, Db, UTzCDS, UTzFDS, DBCtrls;

type
  MyEncryptionType = (doEncrypt, doDecrypt, doBoth, doNone);

  TForm1 = class(TForm)
    TzDbf0: TDataSource;
    TzDbf1: TTzDbf;
    TzGrid1: TTzGrid;
    DBMemo1: TDBMemo;
    TopazButton: TButton;
    OthersButton: TButton;
    EncryptButton: TButton;
    DecryptButton: TButton;
    ChangeEncryptionButton: TButton;
    procedure EncryptButtonClick(Sender: TObject);
    procedure OthersButtonClick(Sender: TObject);
    procedure TopazButtonClick(Sender: TObject);
    procedure DecryptButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure ChangeEncryptionButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FEncrypted : Boolean;
    FUseMethodA: Boolean;
    procedure SpecialSetEncrypt(eType: MyEncryptionType);
    procedure CheckCaption;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  { decrypt the file for the next demo }
  if FEncrypted then DecryptButtonClick(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if TzDbf1.ReadOnly then
    ShowMessage('Switch to TOPAZ way first...')
  else
    TzDbf1.Pack;
end;

procedure TForm1.ChangeEncryptionButtonClick(Sender: TObject);
begin
  { we are about to change the encoding method.
    if the file is not encrypted we simply flip the flag:
  }
  if NOT FEncrypted then
    FUseMethodA := NOT FUseMethodA
  else begin
    { if the file is already encrypted then we need to decrypt
      the whole file, flip the flag and then encrypt the file
      using the new method. NEVER change encryption/decryption
      routines while the file is encrypted. You'll end up losing
      your data. }
    DecryptButtonClick(Sender);
    FUseMethodA := NOT FUseMethodA;
    EncryptButtonClick(Sender);
  end;
  CheckCaption;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CheckCaption;
end;

end.

