//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Ufilt_cb.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "aTzGrids"
#pragma link "aTzNav"
#pragma link "TzPrimDS"
#pragma link "UCommon"
#pragma link "UTzCDS"
#pragma link "UTzFDS"
#pragma link "TzPrimDS"
#pragma resource "*.dfm"
#pragma warn -lvc

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RecCountButtonClick(TObject *Sender)
{
  int count;
  AnsiString save;
  /*
    In older versions of TOPAZ FilteredRecCount property
    did not exist. So this is a new property added to
    the library by the popular demand.
    Note that neither TOPAZ nor dBASE keep track of the number
    of filtered records. RecCount property will return the
    number of *all* records in the database. To get the
    number of valid (filtered) records TOPAZ needs to skip
    through the entire database. This scanning may take
    a long time if the database is big. You need to notify
    the user that counting is in progress. In this sample
    we simply change the caption of the button. We also
    disable the button while counting is in progress.
  */

  save = RecCountButton->Caption;
  RecCountButton->Caption = "Counting...";
  RecCountButton->Enabled = FALSE;
  Application->ProcessMessages(); //{ let the app repaint the caption }
  count = TzDbf1->FilteredRecCount;
  RecCountButton->Caption = save;
  ShowMessage("Number of filtered records: "+IntToStr(count));
  RecCountButton->Enabled = TRUE;
}
//---------------------------------------------------------------------------

/* Filter or While callback routine must be a method
   of a class, which returns a Boolean result.

   The following callback will filter out any records
   with the YEAR field bigger than 1970 and smaller
   than 1940. */

Boolean __fastcall TForm1::MyFilterCallBack()
{
  int x = TzDbf1->GetLongField("Year");
  //{ or "int x = TzDbf1->FieldByName("Year").AsInteger;" }
  return (1940 <= x) && (x <= 1970);
}

/* A call to SetWhileToCB() would be very similar to
  the call to SetFilterToCB() below. With WHILE you need
  to position the database to a record that matches
  the WHILE condition, before you set the while condition
  otherwise you won't see *any* records. Also, you do not
  need a call to GoTop() when you set WHILE condition.

  procedure TForm1.WhileButtonClick(Sender: TObject);
  begin
    position the database to a valid record...
    TzDbf1.SetWhileToCB(MyWhileCallBack);
  end;
*/

void __fastcall TForm1::FilterButtonClick(TObject *Sender)
{
  TzDbf1->SetFilterToCB(MyFilterCallBack);
  TzDbf1->GoTop();
}
//---------------------------------------------------------------------------

