//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "UnitVF.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TzPrimDs"
#pragma link "UCommon"
#pragma link "UTzCDS"
#pragma link "UTzMDS"
#pragma link "aTzGrids"
#pragma link "aTzNav"
#pragma link "TzPrimDS"
#pragma resource "*.dfm"
#pragma warn -lvc


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  SetCenturyOn(); //{ use 4 digit years in date fields }
}
//---------------------------------------------------------------------------
//
// This is the callback function for the virtual file.
//  NOTE: The Virtual File callback must be a MEMBER
//  FUNCTION OF A CLASS which takes NO PARAMETERS and
//  RETURNS ANSI STRING values.
//
//  You do not need to use FAR function calls to use
//  in Virtual File Callbacks.
//

AnsiString __fastcall TForm1::TzVFile1KeyMaker()
{
  if (strlen(FSortField.c_str()) == 0)
   //{ when we get started FSortField is empty, so let us generate
   //  some arbitrary key until the user clicks on the title bar }
    return "NO KEY";
  else
    if (FFieldType == 'D')
      //{ ctod() is a function that is defined in
      //  TIMEDATE. It will convert MM/DD/YY or
      //  whatever (depending on a country settings)
      //  to a "sortable" string of "YYYYMMDD" }
       return CTOD(TzVFile1->GetField(FSortField));
     else
       return TzVFile1->GetField(FSortField);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TzGrid1DepressTitle(TObject *Sender,
      TTzColumn *curColumn)
{
  TzVFile1->Post(); // post the changes if any
  if (curColumn->Field == NULL)
    ShowMessage("Cannot sort on this column");
  else {
    // first we set up the key maker which is
    // based on the following two variables }
    FSortField = curColumn->Field->FieldName;
    FFieldType = GetDBaseType(curColumn->Field); // converts Delphi field types into dBASE

    // then we set AppendMode. At this point TOPAZ will
    //  sort the virtual database. This may take some time...

    if ('A' == tzDialogBox("", "?","Set Sort order to","Ascending Descending"))
      TzVFile1->AppendMode = ASCENDING;
    else
      TzVFile1->AppendMode = DESCENDING;

    //{ and finally we need to repaint the grid or
    //  any of the data-aware controls.
    //  Unfortunately we cannot simply save the database
    //  record and jump to our old position here. Sorting
    //  the virtual database will reassign the record numbers.

    //  Virtual tables do not have/use indexes. Sorting the virtual
    //  table means that the records are physically sorted, so
    //  the record numbers before and after the sort will be
    //  different for any given record.

    TzVFile1->First();
  }
}
//---------------------------------------------------------------------------

