{****************************************************************************}
{*                            T O P A Z   7.5                               *}
{*--------------------------------------------------------------------------*}
{*                Copyright 1988,1999 Software Science Inc.                 *}
{*                      All Rights Reserved Worldwide                       *}
{*--------------------------------------------------------------------------*}
{*             This source code is the exclusive property of:               *}
{*                          Software Science Inc.                           *}
{*                     7 Mt. Lassen Drive, Suite C-250                      *}
{*                        San Rafael, CA 94903 USA                          *}
{*--------------------------------------------------------------------------*}
{*       Unauthorized distribution or disclosure of this source code        *}
{*                or modification or removal of this notice                 *}
{*              constitutes a breach of the license agreement               *}
{*                                                                          *}
{****************************************************************************}

unit TopazReg;

{.$define USE_DBDS}

interface

uses Classes, DsgnIntf, Dialogs;

procedure Register;

implementation

uses
 {$ifdef USE_DBDS}
  Windows, Messages, SysUtils, Graphics,
  Controls, Forms, DB, UTzFDS, UTzMDS,
 {$else}
  VFiles, aTzImage,
 {$endif}
  UCommon, UTzODbf, UTzDbf, UTzProps,
  aTzMaskp, aTzGrids, aTzMask, aTzEdit,
  aTzText, aTzNav, UOnlyOne,
 {$ifndef CBUILDER}
  aTzSpin,
 {$endif}

  PrnLabel, SplitPan, PrlDsgn, PrlPage,
  DsgnStyl, Perstyle,
  tzScaler, TzLabel,
  aTzList, aTzChkbx, aTzRadio, aTzCombo, aTzMemo;

{$ifdef WIN32}
 {$ifdef CBUILDER}
  {$R TOPAZR32.DCR}
 {$else}
  {$R RESOURCE\TOPAZR32.DCR}
 {$endif}
{$else}
 {$R RESOURCE\TOPAZR16.DCR}
{$endif}

procedure Register;
begin
  RegisterComponents('SSI', [TTzDbf]);
{$ifdef USE_DBDS}
 {$ifndef CBUILDER}
  RegisterComponents('SSI', [TTzVFile]);
 {$endif}
{$else}
  RegisterComponents('SSI', [TTzImage]);
{$endif}
  RegisterComponents('SSI', [TTzGrid]);
  RegisterComponents('SSI', [TTzNavigator]);
  RegisterComponents('SSI', [TTzMemo]);
  RegisterComponents('SSI', [TTzText]);
  RegisterComponents('SSI', [TTzTextExpr]);
  RegisterComponents('SSI', [TTzCheckBox]);
  RegisterComponents('SSI', [TTzRadioGroup]);
  RegisterComponents('SSI', [TTzComboBox]);
  RegisterComponents('SSI', [TTzListBox]);
  RegisterComponents('SSI', [TTzEdit]);
  RegisterComponents('SSI', [TTzOnlyOne]);
 {$ifndef CBUILDER}
  RegisterComponents('SSI', [TTzSpinEdit]);
 {$endif}
  RegisterComponents('SSI', [TTzMaskEdit]);
  RegisterComponents('SSI', [TTzScaler]);

  RegisterComponents('SSI', [TTzLabel]);

  RegisterComponents('SSI', [TTzPrintLabel]);
  RegisterComponents('SSI', [TTzCollapser]);

{$ifdef USE_DBDS}
  RegisterClasses([TTzDateField]);
  RegisterPropertyEditor(TypeInfo(TFileName), TTzDbf, 'DbfFileName', TDbfFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings),  TTzDbf, 'DbfFields', TDbfFieldsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings),  TTzDbf, 'IndexList', TDbfIndexProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TTzVFile, 'DbfFileName', TDbfFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings),  TTzVFile, 'DbfFields', TDbfFieldsProperty);
{$else}
  RegisterPropertyEditor(TypeInfo(String),  TTzDbf,       'DbfFileName',TDbfFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings),TTzDbf,       'DbfFields',  TDbfFieldsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings),TTzDbf,       'IndexList',  TDbfIndexProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzEdit,      'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzMemo,      'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzText,      'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzCheckBox,  'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzRadioGroup,'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzComboBox,  'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzListBox,   'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzImage,     'DataField',  TDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzSpinEdit,  'DataField',  TDataFieldProperty);
{$endif}

  RegisterComponentEditor(TTzPrintLabel, TPrintLabelEditor);
  RegisterPropertyEditor(TypeInfo(TLabelPage), nil, '', TLabelPageProperty);

  RegisterPropertyEditor(TypeInfo(TPersistentStyle), nil, '', TStyleClassProperty);
  RegisterPropertyEditor(Typeinfo(string), TPersistentStyle, 'Style', TStyleNameProperty);

  RegisterPropertyEditor(TypeInfo(String),  TTzMaskEdit,  'EditMask',   TTzMaskProperty);
  RegisterPropertyEditor(TypeInfo(String),  TTzEdit,      'EditMask',   TTzMaskProperty);

  RegisterPropertyEditor(TypeInfo(TTzGridColumns),TTzGrid,'Columns',  TTzColumnAttributesProperty);
  RegisterComponentEditor(TTzGrid, TTzGridEditor);
end;

end.
